Index: pjproject/trunk/pjmedia/src/pjmedia-codec/openh264.cpp
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia-codec/openh264.cpp	(revision 6156)
+++ pjproject/trunk/pjmedia/src/pjmedia-codec/openh264.cpp	(revision 6157)
@@ -169,4 +169,5 @@
 
 static void log_print(void* ctx, int level, const char* string) {
+    PJ_UNUSED_ARG(ctx);
     PJ_LOG(4,("[OPENH264_LOG]", "[L%d] %s", level, string));
 }
Index: pjproject/trunk/pjmedia/src/pjmedia/echo_speex.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/echo_speex.c	(revision 6156)
+++ pjproject/trunk/pjmedia/src/pjmedia/echo_speex.c	(revision 6157)
@@ -60,5 +60,6 @@
 {
     speex_ec *echo;
-    int i, sampling_rate;
+    int sampling_rate;
+    unsigned i;
 
     *p_echo = NULL;
Index: pjproject/trunk/pjmedia/src/pjmedia/vid_codec_util.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/vid_codec_util.c	(revision 6156)
+++ pjproject/trunk/pjmedia/src/pjmedia/vid_codec_util.c	(revision 6157)
@@ -787,5 +787,6 @@
 	} else if (pj_stricmp(&fmtp->param[i].name, &PROFILE_ID) == 0) {
 	    tmp = pj_strtoul(&fmtp->param[i].val);
-	    vpx_fmtp->profile_id = PJ_MAX(tmp, vpx_fmtp->profile_id);
+	    vpx_fmtp->profile_id = (pj_uint8_t)
+				   PJ_MAX(tmp, vpx_fmtp->profile_id);
 	}
     }
Index: pjproject/trunk/pjnath/src/pjnath/turn_session.c
===================================================================
--- pjproject/trunk/pjnath/src/pjnath/turn_session.c	(revision 6156)
+++ pjproject/trunk/pjnath/src/pjnath/turn_session.c	(revision 6157)
@@ -1327,5 +1327,5 @@
 
     sess = (pj_turn_session*) pj_stun_session_get_user_data(stun);
-    if (*sess->cb.on_stun_send_pkt) {
+    if (sess->cb.on_stun_send_pkt) {
     	return (*sess->cb.on_stun_send_pkt)(sess, (const pj_uint8_t*)pkt,
 				       	    (unsigned)pkt_size,
Index: pjproject/trunk/pjnath/src/pjnath/turn_sock.c
===================================================================
--- pjproject/trunk/pjnath/src/pjnath/turn_sock.c	(revision 6156)
+++ pjproject/trunk/pjnath/src/pjnath/turn_sock.c	(revision 6157)
@@ -889,6 +889,4 @@
 			      pj_ssize_t sent)
 {
-    unsigned header_len, sent_size;
-
     /* Don't report to callback if this is internal message. */
     if (send_key == &turn_sock->int_send_key) {
@@ -897,4 +895,6 @@
 
     if (turn_sock->cb.on_data_sent) {
+	pj_ssize_t header_len, sent_size;
+
         /* Remove the length of packet header from sent size. */
 	header_len = turn_sock->pkt_len - turn_sock->body_len;
Index: pjproject/trunk/pjsip/src/pjsip-ua/sip_reg.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip-ua/sip_reg.c	(revision 6156)
+++ pjproject/trunk/pjsip/src/pjsip-ua/sip_reg.c	(revision 6157)
@@ -46,5 +46,5 @@
 #define REGC_TSX_TIMEOUT	33000
 
-enum { NOEXP = PJSIP_REGC_EXPIRATION_NOT_SPECIFIED };
+#define NOEXP			PJSIP_REGC_EXPIRATION_NOT_SPECIFIED
 
 static const pj_str_t XUID_PARAM_NAME = { "x-uid", 5 };
Index: pjproject/trunk/pjsip/src/pjsua2/media.cpp
===================================================================
--- pjproject/trunk/pjsip/src/pjsua2/media.cpp	(revision 6156)
+++ pjproject/trunk/pjsip/src/pjsua2/media.cpp	(revision 6157)
@@ -1847,5 +1847,5 @@
     packet_loss = config.packet_loss;
     complexity = config.complexity;
-    cbr = config.cbr;
+    cbr = PJ2BOOL(config.cbr);
 }
 
Index: pjproject/trunk/third_party/build/speex/config.h
===================================================================
--- pjproject/trunk/third_party/build/speex/config.h	(revision 6156)
+++ pjproject/trunk/third_party/build/speex/config.h	(revision 6157)
@@ -29,4 +29,5 @@
 #   pragma warning(disable: 4456)   // declaration of '[var]' hides previous local declaration
 #   pragma warning(disable: 4267)   // conversion from 'size_t' to 'int', possible loss of data
+#   pragma warning(disable: 4706)   // assignment within conditional expression
 //#   pragma warning(disable: 4701)   // local variable used without initialized
 #endif