Index: pjproject/trunk/pjmedia/src/pjmedia/vid_port.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/vid_port.c	(revision 6158)
+++ pjproject/trunk/pjmedia/src/pjmedia/vid_port.c	(revision 6159)
@@ -793,5 +793,4 @@
         const pjmedia_format *fmt;
 	pjmedia_video_apply_fmt_param vafp;
-	pj_status_t status;
 	pjmedia_frame frame;
 
Index: pjproject/trunk/pjmedia/src/pjmedia/vid_stream.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/vid_stream.c	(revision 6158)
+++ pjproject/trunk/pjmedia/src/pjmedia/vid_stream.c	(revision 6159)
@@ -1208,5 +1208,5 @@
 	if (stream->info.rc_cfg.method==PJMEDIA_VID_STREAM_RC_SIMPLE_BLOCKING)
 	{
-	    pj_timestamp now, next_send_ts, total_send_ts;
+	    pj_timestamp next_send_ts, total_send_ts;
 
 	    total_send_ts.u64 = total_sent * stream->ts_freq.u64 * 8 /
Index: pjproject/trunk/pjnath/src/pjnath/stun_session.c
===================================================================
--- pjproject/trunk/pjnath/src/pjnath/stun_session.c	(revision 6158)
+++ pjproject/trunk/pjnath/src/pjnath/stun_session.c	(revision 6159)
@@ -623,6 +623,6 @@
      */
     while (!pj_list_empty(&sess->cached_response_list)) {
-	pj_stun_tx_data *tdata = sess->cached_response_list.next;
-	destroy_tdata(tdata, PJ_TRUE);
+	pj_stun_tx_data *tmp_tdata = sess->cached_response_list.next;
+	destroy_tdata(tmp_tdata, PJ_TRUE);
     }
 
Index: pjproject/trunk/pjsip-apps/src/pjsua/pjsua_app_cli.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/pjsua/pjsua_app_cli.c	(revision 6158)
+++ pjproject/trunk/pjsip-apps/src/pjsua/pjsua_app_cli.c	(revision 6159)
@@ -2502,16 +2502,16 @@
 	li_list[0] = '\0';
 	for (j=0; j<info.listener_cnt; ++j) {
-	    char s[10];
-	    pj_ansi_snprintf(s, sizeof(s), "%d%s",
+	    char str_info[10];
+	    pj_ansi_snprintf(str_info, sizeof(str_info), "%d%s",
 			     info.listeners[j],
 			     (j==info.listener_cnt-1)?"":",");
-	    pj_ansi_strcat(li_list, s);
+	    pj_ansi_strcat(li_list, str_info);
 	}
 	tr_list[0] = '\0';
 	for (j=0; j<info.transmitter_cnt; ++j) {
-	    char s[10];
-	    pj_ansi_snprintf(s, sizeof(s), "%d%s", info.transmitters[j],
+	    char str_info[10];
+	    pj_ansi_snprintf(str_info, sizeof(str_info), "%d%s", info.transmitters[j],
 			     (j==info.transmitter_cnt-1)?"":",");
-	    pj_ansi_strcat(tr_list, s);
+	    pj_ansi_strcat(tr_list, str_info);
 	}
 	pjmedia_fourcc_name(info.format.id, s);
Index: pjproject/trunk/pjsip-apps/src/pjsua/pjsua_app_legacy.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/pjsua/pjsua_app_legacy.c	(revision 6158)
+++ pjproject/trunk/pjsip-apps/src/pjsua/pjsua_app_legacy.c	(revision 6159)
@@ -632,17 +632,17 @@
 		    li_list[0] = '\0';
 		    for (j=0; j<info.listener_cnt; ++j) {
-			char s[10];
-			pj_ansi_snprintf(s, sizeof(s), "%d%s",
+			char str_info[10];
+			pj_ansi_snprintf(str_info, sizeof(str_info), "%d%s",
 					 info.listeners[j],
 					 (j==info.listener_cnt-1)?"":",");
-			pj_ansi_strcat(li_list, s);
+			pj_ansi_strcat(li_list, str_info);
 		    }
 		    tr_list[0] = '\0';
 		    for (j=0; j<info.transmitter_cnt; ++j) {
-			char s[10];
-			pj_ansi_snprintf(s, sizeof(s), "%d%s",
+			char str_info[10];
+			pj_ansi_snprintf(str_info, sizeof(str_info), "%d%s",
 					 info.transmitters[j],
 					 (j==info.transmitter_cnt-1)?"":",");
-			pj_ansi_strcat(tr_list, s);
+			pj_ansi_strcat(tr_list, str_info);
 		    }
 		    pjmedia_fourcc_name(info.format.id, s);
Index: pjproject/trunk/pjsip/src/pjsua-lib/pjsua_dump.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsua-lib/pjsua_dump.c	(revision 6158)
+++ pjproject/trunk/pjsip/src/pjsua-lib/pjsua_dump.c	(revision 6159)
@@ -372,13 +372,13 @@
 	if (call_med->type == PJMEDIA_TYPE_AUDIO) {
 	    if (pjsua_snd_is_active()) {
-	    	pjmedia_echo_stat stat;
+	    	pjmedia_echo_stat ec_stat;
 	    	pj_status_t status;
 	    	
-	    	status = pjsua_get_ec_stat(&stat);
+	    	status = pjsua_get_ec_stat(&ec_stat);
 	    	if (status == PJ_SUCCESS) {
 		    len = pj_ansi_snprintf(p, end-p, "   %s  EC stat: %.*s\n",
 		    			   indent,
-		    			   (int)stat.stat_info.slen,
-		    			   stat.stat_info.ptr);
+		    			   (int)ec_stat.stat_info.slen,
+		    			   ec_stat.stat_info.ptr);
 		    if (len < 1 || len >= end-p) {
 	    	    	*p = '\0';